#!/usr/bin/env python
# coding: utf-8

# In[52]:


import math
import cmath
from scipy.optimize import minimize
from scipy import constants

f=50e6
zl=59.49-175.4j

#network
qc=1000
ql=300
#tapped coil
p=0.003
r=0.01
n=6

# In[53]:


def wcf(n,r,l):
  return constants.mu_0*n**2*r*(math.log(1+math.pi*r/l)+1/(2.3004+1.622*l/r+0.4409*(l/r)**2))

def vswr(args):
  tap,c1=args
  lt=wcf(n,r,l)
  l1=wcf(n*tap,r,l*tap)
  l2=wcf(n*(1-tap),r,l*(1-tap))
  m=-(lt-l1-l2)/2
  rlt=2*math.pi*f*lt/ql
  y=1/zl
  y=y+2*math.pi*f*c1*(1/qc+1j)
  zl2p=rlt*(1-tap)+2*math.pi*f*(l2-m)*1j
  z=1/y+zl2p
  y=1/z
  yl1p=1/(rlt*tap+2*math.pi*f*(l1-m)*1j)
  y=y+yl1p
  z=1/y
  zm=2*math.pi*f*m*1j
  z=z+zm
  y=1/z
  gamma=(z-50)/(z+50)
  rho=abs(gamma)
  vswr=(1+rho)/(1-rho)
  return vswr


# In[69]:


l=n*p

#starting guess
tap=0.5
c1=20e-12

x0=[tap,c1]
res=minimize(vswr,x0,method='Nelder-Mead')

print()
print("zl:",zl)
print('pitch: {:0.5f} m, radius: {:0.5f} m, turns: {:0.2f}, length: {:0.5f} m, Ql: {:0.0f}, Qc: {:0.0f}'.format(p,r,n,p*n,ql,qc))
print()
print('VSWR={:0.5f}, tap={:0.3f} (%), c1={:0.5f} (pF)'.format(res.fun,res.x[0]*100,res.x[1]*1e12))


# In[ ]:




